diff -u -r gdm-2.28.2.pristine/gui/simple-greeter/gdm-user-manager.c gdm-2.28.2/gui/simple-greeter/gdm-user-manager.c
--- gdm-2.28.2.pristine/gui/simple-greeter/gdm-user-manager.c	2010-01-22 11:17:50.731384714 -0500
+++ gdm-2.28.2/gui/simple-greeter/gdm-user-manager.c	2010-01-24 16:57:33.169124287 -0500
@@ -1036,718 +706,145 @@
                                      G_CALLBACK (seat_session_removed),
                                      manager,
                                      NULL);
-        manager->priv->seat_proxy = proxy;
-
-}
-
-/**
- * gdm_manager_get_user:
- * @manager: the manager to query.
- * @username: the login name of the user to get.
- *
- * Retrieves a pointer to the #GdmUser object for the login named @username
- * from @manager. This pointer is not a reference, and should not be released.
- *
- * Returns: a pointer to a #GdmUser object.
- **/
-GdmUser *
-gdm_user_manager_get_user (GdmUserManager *manager,
-                           const char     *username)
-{
-        GdmUser *user;
-
-        g_return_val_if_fail (GDM_IS_USER_MANAGER (manager), NULL);
-        g_return_val_if_fail (username != NULL && username[0] != '\0', NULL);
-
-        user = g_hash_table_lookup (manager->priv->users, username);
-
-        if (user == NULL) {
-                struct passwd *pwent;
-
-                pwent = getpwnam (username);
-
-                if (pwent != NULL) {
-                        user = add_new_user_for_pwent (manager, pwent);
-                }
-        }
-
-        return user;
-}
-
-GdmUser *
-gdm_user_manager_get_user_by_uid (GdmUserManager *manager,
-                                  uid_t           uid)
-{
-        GdmUser       *user;
-        struct passwd *pwent;
-
-        g_return_val_if_fail (GDM_IS_USER_MANAGER (manager), NULL);
-
-        pwent = getpwuid (uid);
-        if (pwent == NULL) {
-                g_warning ("GdmUserManager: unable to lookup uid %d", (int)uid);
-                return NULL;
-        }
-
-        user = g_hash_table_lookup (manager->priv->users, pwent->pw_name);
-
-        if (user == NULL) {
-                user = add_new_user_for_pwent (manager, pwent);
-        }
-
-        return user;
+        manager->seat_proxy = proxy;
 }
 
 static void
-listify_hash_values_hfunc (gpointer key,
-                           gpointer value,
-                           gpointer user_data)
-{
-        GSList **list = user_data;
-
-        *list = g_slist_prepend (*list, value);
-}
-
-GSList *
-gdm_user_manager_list_users (GdmUserManager *manager)
-{
-        GSList *retval;
-
-        g_return_val_if_fail (GDM_IS_USER_MANAGER (manager), NULL);
-
-        retval = NULL;
-        g_hash_table_foreach (manager->priv->users, listify_hash_values_hfunc, &retval);
-
-        return g_slist_sort (retval, (GCompareFunc) gdm_user_collate);
-}
-
-static gboolean
-parse_value_as_ulong (const char *value,
-                      gulong     *ulongval)
-{
-        char  *end_of_valid_long;
-        glong  long_value;
-        gulong ulong_value;
-
-        errno = 0;
-        long_value = strtol (value, &end_of_valid_long, 10);
-
-        if (*value == '\0' || *end_of_valid_long != '\0') {
-                return FALSE;
-        }
-
-        ulong_value = long_value;
-        if (ulong_value != long_value || errno == ERANGE) {
-                return FALSE;
-        }
-
-        *ulongval = ulong_value;
-
-        return TRUE;
-}
-
-static gboolean
-parse_ck_history_line (const char *line,
-                       char      **user_namep,
-                       gulong     *frequencyp)
-{
-        GRegex     *re;
-        GMatchInfo *match_info;
-        gboolean    res;
-        gboolean    ret;
-        GError     *error;
-
-        ret = FALSE;
-        re = NULL;
-        match_info = NULL;
-
-        error = NULL;
-        re = g_regex_new ("(?P<username>[0-9a-zA-Z]+)[ ]+(?P<frequency>[0-9]+)", 0, 0, &error);
-        if (re == NULL) {
-                if (error != NULL) {
-                        g_critical ("%s", error->message);
-                } else {
-                        g_critical ("Error in regex call");
-                }
-                goto out;
-        }
-
-        g_regex_match (re, line, 0, &match_info);
-
-        res = g_match_info_matches (match_info);
-        if (! res) {
-                g_warning ("Unable to parse history: %s", line);
-                goto out;
-        }
-
-        if (user_namep != NULL) {
-                *user_namep = g_match_info_fetch_named (match_info, "username");
-        }
-
-        if (frequencyp != NULL) {
-                char *freq;
-                freq = g_match_info_fetch_named (match_info, "frequency");
-                res = parse_value_as_ulong (freq, frequencyp);
-                g_free (freq);
-                if (! res) {
-                        goto out;
-                }
-        }
-
-        ret = TRUE;
-
- out:
-        if (match_info != NULL) {
-                g_match_info_free (match_info);
-        }
-        if (re != NULL) {
-                g_regex_unref (re);
-        }
-        return ret;
-}
-
-static void
-process_ck_history_line (GdmUserManager *manager,
-                         const char     *line)
-{
-        gboolean res;
-        char    *username;
-        gulong   frequency;
-        GdmUser *user;
-
-        frequency = 0;
-        username = NULL;
-        res = parse_ck_history_line (line, &username, &frequency);
-        if (! res) {
-                return;
-        }
-
-        if (g_hash_table_lookup (manager->priv->exclusions, username)) {
-                g_debug ("GdmUserManager: excluding user '%s'", username);
-                g_free (username);
-                return;
-        }
-
-        user = gdm_user_manager_get_user (manager, username);
-        if (user == NULL) {
-                g_debug ("GdmUserManager: unable to lookup user '%s'", username);
-                g_free (username);
-                return;
-        }
-
-        g_object_set (user, "login-frequency", frequency, NULL);
-        g_signal_emit (manager, signals [USER_LOGIN_FREQUENCY_CHANGED], 0, user);
-        g_free (username);
-}
-
-static gboolean
-ck_history_watch (GIOChannel     *source,
-                  GIOCondition    condition,
-                  GdmUserManager *manager)
-{
-        GIOStatus status;
-        gboolean  done  = FALSE;
-
-        g_return_val_if_fail (manager != NULL, FALSE);
-
-        if (condition & G_IO_IN) {
-                char   *str;
-                GError *error;
-
-                error = NULL;
-                status = g_io_channel_read_line (source, &str, NULL, NULL, &error);
-                if (error != NULL) {
-                        g_warning ("GdmUserManager: unable to read line: %s", error->message);
-                        g_error_free (error);
-                }
-
-                if (status == G_IO_STATUS_NORMAL) {
-                        g_debug ("GdmUserManager: history output: %s", str);
-                        process_ck_history_line (manager, str);
-                } else if (status == G_IO_STATUS_EOF) {
-                        done = TRUE;
-                }
-
-                g_free (str);
-        } else if (condition & G_IO_HUP) {
-                done = TRUE;
-        }
-
-        if (done) {
-                g_signal_emit (G_OBJECT (manager), signals[USERS_LOADED], 0);
-
-                manager->priv->ck_history_id = 0;
-                return FALSE;
-        }
-
-        return TRUE;
-}
-
-static void
-reload_ck_history (GdmUserManager *manager)
+gdm_user_manager_init (GdmUserManager *manager)
 {
-        char       *command;
-        const char *seat_id;
-        GError     *error;
-        gboolean    res;
-        char      **argv;
-        int         standard_out;
-        GIOChannel *channel;
-
-        seat_id = NULL;
-        if (manager->priv->seat_id != NULL
-            && g_str_has_prefix (manager->priv->seat_id, "/org/freedesktop/ConsoleKit/")) {
+        GError *error = NULL;
 
-                seat_id = manager->priv->seat_id + strlen ("/org/freedesktop/ConsoleKit/");
-        }
+        manager->user_by_object_path = g_hash_table_new_full (g_str_hash,
+                                                              g_str_equal,
+                                                              NULL,
+                                                              g_object_unref);
+        manager->user_by_name = g_hash_table_new_full (g_str_hash,
+                                                       g_str_equal,
+                                                       NULL,
+                                                       g_object_unref);
 
-        if (seat_id == NULL) {
-                g_warning ("Unable to find users: no seat-id found");
-                return;
-        }
+        manager->sessions = g_hash_table_new_full (g_str_hash,
+                                                   g_str_equal,
+                                                   g_free,
+                                                   g_free);
+
+        manager->bus = dbus_g_bus_get (DBUS_BUS_SYSTEM, &error);
+        if (manager->bus == NULL) {
+                g_warning ("Couldn't connect to system bus: %s", error->message);
+                g_error_free (error);
+                goto error;
+        }
+
+        manager->proxy = dbus_g_proxy_new_for_name (manager->bus,
+                                                    "org.freedesktop.Accounts",
+                                                    "/org/freedesktop/Accounts",
+                                                    "org.freedesktop.Accounts");
+
+        dbus_g_proxy_add_signal (manager->proxy, "UserAdded", DBUS_TYPE_G_OBJECT_PATH, G_TYPE_INVALID);
+        dbus_g_proxy_add_signal (manager->proxy, "UserDeleted", DBUS_TYPE_G_OBJECT_PATH, G_TYPE_INVALID);
+
+        dbus_g_proxy_connect_signal (manager->proxy, "UserAdded",
+                                     G_CALLBACK (user_added_handler), manager, NULL);
+        dbus_g_proxy_connect_signal (manager->proxy, "UserDeleted",
+                                     G_CALLBACK (user_deleted_handler), manager, NULL);
 
-        command = g_strdup_printf ("ck-history --frequent --seat='%s' --session-type=''",
-                                   seat_id);
-        g_debug ("GdmUserManager: running '%s'", command);
-        error = NULL;
-        if (! g_shell_parse_argv (command, NULL, &argv, &error)) {
-                if (error != NULL) {
-                        g_warning ("Could not parse command: %s", error->message);
-                        g_error_free (error);
-                } else {
-                        g_warning ("Could not parse command");
-                }
-                goto out;
-        }
-
-        error = NULL;
-        res = g_spawn_async_with_pipes (NULL,
-                                        argv,
-                                        NULL,
-                                        G_SPAWN_SEARCH_PATH,
-                                        NULL,
-                                        NULL,
-                                        NULL, /* pid */
-                                        NULL,
-                                        &standard_out,
-                                        NULL,
-                                        &error);
-        g_strfreev (argv);
-        if (! res) {
-                if (error != NULL) {
-                        g_warning ("Unable to run ck-history: %s", error->message);
-                        g_error_free (error);
-                } else {
-                        g_warning ("Unable to run ck-history");
-                }
-                goto out;
-        }
+        get_seat_proxy (manager);
 
-        channel = g_io_channel_unix_new (standard_out);
-        g_io_channel_set_close_on_unref (channel, TRUE);
-        g_io_channel_set_flags (channel,
-                                g_io_channel_get_flags (channel) | G_IO_FLAG_NONBLOCK,
-                                NULL);
-        manager->priv->ck_history_id = g_io_add_watch (channel,
-                                                       G_IO_IN | G_IO_HUP | G_IO_ERR | G_IO_NVAL,
-                                                       (GIOFunc)ck_history_watch,
-                                                       manager);
-        g_io_channel_unref (channel);
+        get_users (manager);
 
- out:
-        g_free (command);
+ error: ;
 }
 
 static void
-reload_passwd (GdmUserManager *manager)
+gdm_user_manager_finalize (GObject *object)
 {
-        struct passwd *pwent;
-        GSList        *old_users;
-        GSList        *new_users;
-        GSList        *list;
-        GSList        *dup;
-        FILE          *fp;
-
-        old_users = NULL;
-        new_users = NULL;
-
-        errno = 0;
-        fp = fopen (PATH_PASSWD, "r");
-        if (fp == NULL) {
-                g_warning ("Unable to open %s: %s", PATH_PASSWD, g_strerror (errno));
-                goto out;
-        }
-
-        g_hash_table_foreach (manager->priv->users, listify_hash_values_hfunc, &old_users);
-        g_slist_foreach (old_users, (GFunc) g_object_ref, NULL);
-
-        /* Make sure we keep users who are logged in no matter what. */
-        for (list = old_users; list; list = list->next) {
-                if (gdm_user_get_num_sessions (list->data) > 0) {
-                        g_object_freeze_notify (G_OBJECT (list->data));
-                        _gdm_user_show_short_display_name (list->data);
-                        new_users = g_slist_prepend (new_users, g_object_ref (list->data));
-                }
-        }
-
-        for (pwent = fgetpwent (fp); pwent != NULL; pwent = fgetpwent (fp)) {
-                GdmUser *user;
-
-                user = NULL;
-
-                /* Skip users below MinimalUID... */
-                if (pwent->pw_uid < DEFAULT_MINIMAL_UID) {
-                        continue;
-                }
-
-                /* ...And users w/ invalid shells... */
-                if (pwent->pw_shell == NULL ||
-                    !g_hash_table_lookup (manager->priv->shells, pwent->pw_shell)) {
-                        g_debug ("GdmUserManager: skipping user with bad shell: %s", pwent->pw_name);
-                        continue;
-                }
-
-                /* ...And explicitly excluded users */
-                if (g_hash_table_lookup (manager->priv->exclusions, pwent->pw_name)) {
-                        g_debug ("GdmUserManager: explicitly skipping user: %s", pwent->pw_name);
-                        continue;
-                }
-
-                user = g_hash_table_lookup (manager->priv->users, pwent->pw_name);
-
-                /* Update users already in the *new* list */
-                if (g_slist_find (new_users, user)) {
-                        _gdm_user_update (user, pwent);
-                        continue;
-                }
-
-                if (user == NULL) {
-                        user = create_user (manager);
-                } else {
-                        g_object_ref (user);
-                }
-
-                /* Freeze & update users not already in the new list */
-                g_object_freeze_notify (G_OBJECT (user));
-                _gdm_user_update (user, pwent);
-
-                new_users = g_slist_prepend (new_users, user);
-        }
-
-        /* Go through and handle removed users */
-        for (list = old_users; list; list = list->next) {
-                if (! g_slist_find (new_users, list->data)) {
-                        g_signal_emit (manager, signals[USER_REMOVED], 0, list->data);
-                        g_hash_table_remove (manager->priv->users,
-                                             gdm_user_get_user_name (list->data));
-                }
-        }
-
-        /* Go through and handle added users or update display names */
-        for (list = new_users; list; list = list->next) {
-                if (g_slist_find (old_users, list->data)) {
-                        dup = g_slist_find_custom (new_users,
-                                                   list->data,
-                                                   match_real_name_cmpfunc);
-                        if (dup != NULL) {
-                                _gdm_user_show_full_display_name (list->data);
-                                _gdm_user_show_full_display_name (dup->data);
-                        }
-                } else {
-                        add_user (manager, list->data);
-                }
-        }
-
- out:
-        /* Cleanup */
-
-        fclose (fp);
-
-        g_slist_foreach (new_users, (GFunc) g_object_thaw_notify, NULL);
-        g_slist_foreach (new_users, (GFunc) g_object_unref, NULL);
-        g_slist_free (new_users);
-
-        g_slist_foreach (old_users, (GFunc) g_object_unref, NULL);
-        g_slist_free (old_users);
-}
+        GdmUserManager *manager;
 
-static void
-reload_users (GdmUserManager *manager)
-{
-        reload_ck_history (manager);
-        reload_passwd (manager);
-}
+        manager = GDM_USER_MANAGER (object);
 
-static gboolean
-reload_users_timeout (GdmUserManager *manager)
-{
-        reload_users (manager);
-        manager->priv->reload_id = 0;
+        g_hash_table_destroy (manager->user_by_object_path);
+        g_hash_table_destroy (manager->user_by_name);
+        g_hash_table_destroy (manager->sessions);
 
-        return FALSE;
+        G_OBJECT_CLASS (gdm_user_manager_parent_class)->finalize (object);
 }
 
-static void
-queue_reload_users (GdmUserManager *manager)
+GdmUserManager *
+gdm_user_manager_ref_default (void)
 {
-        if (manager->priv->reload_id > 0) {
-                return;
+        if (user_manager_object != NULL) {
+                g_object_ref (user_manager_object);
+        } else {
+                user_manager_object = g_object_new (GDM_TYPE_USER_MANAGER, NULL);
+                g_object_add_weak_pointer (user_manager_object,
+                                           (gpointer *) &user_manager_object);
         }
 
-        g_signal_emit (G_OBJECT (manager), signals[LOADING_USERS], 0);
-        manager->priv->reload_id = g_idle_add ((GSourceFunc)reload_users_timeout, manager);
+        return GDM_USER_MANAGER (user_manager_object);
 }
 
-static void
-reload_shells (GdmUserManager *manager)
-{
-        char *shell;
-
-        setusershell ();
-
-        g_hash_table_remove_all (manager->priv->shells);
-        for (shell = getusershell (); shell != NULL; shell = getusershell ()) {
-                /* skip well known not-real shells */
-                if (shell == NULL
-                    || strcmp (shell, "/sbin/nologin") == 0
-                    || strcmp (shell, "/bin/false") == 0) {
-                        g_debug ("GdmUserManager: skipping shell %s", shell);
-                        continue;
-                }
-                g_hash_table_insert (manager->priv->shells,
-                                     g_strdup (shell),
-                                     GUINT_TO_POINTER (TRUE));
-        }
-
-        endusershell ();
+void
+gdm_user_manager_create_user (GdmUserManager *manager,
+                             const char    *user_name,
+                             const char    *real_name)
+{
+        dbus_g_proxy_call_no_reply (manager->proxy,
+                                    "CreateUser",
+                                    G_TYPE_STRING, user_name,
+                                    G_TYPE_STRING, real_name,
+                                    G_TYPE_INVALID);
+}
+
+void
+gdm_user_manager_delete_user (GdmUserManager *manager,
+                             GdmUser        *user,
+                             gboolean       remove_files)
+{
+        dbus_g_proxy_call_no_reply (manager->proxy,
+                                    "DeleteUser",
+                                    G_TYPE_INT64, gdm_user_get_uid (user),
+                                    G_TYPE_BOOLEAN, remove_files,
+                                    G_TYPE_INVALID);
 }
 
-static void
-on_shells_monitor_changed (GFileMonitor     *monitor,
-                           GFile            *file,
-                           GFile            *other_file,
-                           GFileMonitorEvent event_type,
-                           GdmUserManager   *manager)
+GSList *
+gdm_user_manager_list_users (GdmUserManager *manager)
 {
-        if (event_type != G_FILE_MONITOR_EVENT_CHANGED &&
-            event_type != G_FILE_MONITOR_EVENT_CREATED) {
-                return;
-        }
-
-        reload_shells (manager);
-        reload_passwd (manager);
-}
+        GSList *list = NULL;
+        GHashTableIter iter;
+        gpointer value;
 
-static void
-on_passwd_monitor_changed (GFileMonitor     *monitor,
-                           GFile            *file,
-                           GFile            *other_file,
-                           GFileMonitorEvent event_type,
-                           GdmUserManager   *manager)
-{
-        if (event_type != G_FILE_MONITOR_EVENT_CHANGED &&
-            event_type != G_FILE_MONITOR_EVENT_CREATED) {
-                return;
+        g_hash_table_iter_init (&iter, manager->user_by_name);
+        while (g_hash_table_iter_next (&iter, NULL, &value)) {
+                list = g_slist_prepend (list, value);
         }
 
-        reload_passwd (manager);
+        return g_slist_sort (list, (GCompareFunc) gdm_user_collate);
 }
 
-static void
-gdm_user_manager_class_init (GdmUserManagerClass *klass)
-{
-        GObjectClass   *object_class = G_OBJECT_CLASS (klass);
-
-        object_class->finalize = gdm_user_manager_finalize;
-
-        signals [LOADING_USERS] =
-                g_signal_new ("loading-users",
-                              G_TYPE_FROM_CLASS (klass),
-                              G_SIGNAL_RUN_LAST,
-                              G_STRUCT_OFFSET (GdmUserManagerClass, loading_users),
-                              NULL, NULL,
-                              g_cclosure_marshal_VOID__VOID,
-                              G_TYPE_NONE, 0);
-        signals [USERS_LOADED] =
-                g_signal_new ("users-loaded",
-                              G_TYPE_FROM_CLASS (klass),
-                              G_SIGNAL_RUN_LAST,
-                              G_STRUCT_OFFSET (GdmUserManagerClass, users_loaded),
-                              NULL, NULL,
-                              g_cclosure_marshal_VOID__VOID,
-                              G_TYPE_NONE, 0);
-        signals [USER_ADDED] =
-                g_signal_new ("user-added",
-                              G_TYPE_FROM_CLASS (klass),
-                              G_SIGNAL_RUN_LAST,
-                              G_STRUCT_OFFSET (GdmUserManagerClass, user_added),
-                              NULL, NULL,
-                              g_cclosure_marshal_VOID__OBJECT,
-                              G_TYPE_NONE, 1, GDM_TYPE_USER);
-        signals [USER_REMOVED] =
-                g_signal_new ("user-removed",
-                              G_TYPE_FROM_CLASS (klass),
-                              G_SIGNAL_RUN_LAST,
-                              G_STRUCT_OFFSET (GdmUserManagerClass, user_removed),
-                              NULL, NULL,
-                              g_cclosure_marshal_VOID__OBJECT,
-                              G_TYPE_NONE, 1, GDM_TYPE_USER);
-        signals [USER_IS_LOGGED_IN_CHANGED] =
-                g_signal_new ("user-is-logged-in-changed",
-                              G_TYPE_FROM_CLASS (klass),
-                              G_SIGNAL_RUN_LAST,
-                              G_STRUCT_OFFSET (GdmUserManagerClass, user_is_logged_in_changed),
-                              NULL, NULL,
-                              g_cclosure_marshal_VOID__OBJECT,
-                              G_TYPE_NONE, 1, GDM_TYPE_USER);
-        signals [USER_LOGIN_FREQUENCY_CHANGED] =
-                g_signal_new ("user-login-frequency-changed",
-                              G_TYPE_FROM_CLASS (klass),
-                              G_SIGNAL_RUN_LAST,
-                              G_STRUCT_OFFSET (GdmUserManagerClass, user_login_frequency_changed),
-                              NULL, NULL,
-                              g_cclosure_marshal_VOID__OBJECT,
-                              G_TYPE_NONE, 1, GDM_TYPE_USER);
-
-        g_type_class_add_private (klass, sizeof (GdmUserManagerPrivate));
-}
-
-static void
-gdm_user_manager_init (GdmUserManager *manager)
+GdmUser *
+gdm_user_manager_get_user (GdmUserManager *manager,
+                          const gchar   *name)
 {
-        int            i;
-        GFile         *file;
-        GError        *error;
-        const char    *exclude_default[] = DEFAULT_EXCLUDE;
-
-        manager->priv = GDM_USER_MANAGER_GET_PRIVATE (manager);
-
-        /* sessions */
-        manager->priv->sessions = g_hash_table_new_full (g_str_hash,
-                                                         g_str_equal,
-                                                         g_free,
-                                                         g_free);
-
-        /* exclusions */
-        manager->priv->exclusions = g_hash_table_new_full (g_str_hash,
-                                                           g_str_equal,
-                                                           g_free,
-                                                           NULL);
-        for (i = 0; exclude_default[i] != NULL; i++) {
-                g_hash_table_insert (manager->priv->exclusions,
-                                     g_strdup (exclude_default [i]),
-                                     GUINT_TO_POINTER (TRUE));
-        }
-
-        /* /etc/shells */
-        manager->priv->shells = g_hash_table_new_full (g_str_hash,
-                                                       g_str_equal,
-                                                       g_free,
-                                                       NULL);
-        reload_shells (manager);
-        file = g_file_new_for_path (_PATH_SHELLS);
-        error = NULL;
-        manager->priv->shells_monitor = g_file_monitor_file (file,
-                                                             G_FILE_MONITOR_NONE,
-                                                             NULL,
-                                                             &error);
-        if (manager->priv->shells_monitor != NULL) {
-                g_signal_connect (manager->priv->shells_monitor,
-                                  "changed",
-                                  G_CALLBACK (on_shells_monitor_changed),
-                                  manager);
-        } else {
-                if (error != NULL) {
-                        g_warning ("Unable to monitor %s: %s", _PATH_SHELLS, error->message);
-                        g_error_free (error);
-                } else {
-                        g_warning ("Unable to monitor %s", _PATH_SHELLS);
-                }
-        }
-        g_object_unref (file);
-
-        /* /etc/passwd */
-        manager->priv->users = g_hash_table_new_full (g_str_hash,
-                                                      g_str_equal,
-                                                      g_free,
-                                                      (GDestroyNotify) g_object_run_dispose);
-        file = g_file_new_for_path (PATH_PASSWD);
-        manager->priv->passwd_monitor = g_file_monitor_file (file,
-                                                             G_FILE_MONITOR_NONE,
-                                                             NULL,
-                                                             &error);
-        if (manager->priv->passwd_monitor != NULL) {
-                g_signal_connect (manager->priv->passwd_monitor,
-                                  "changed",
-                                  G_CALLBACK (on_passwd_monitor_changed),
-                                  manager);
-        } else {
-                if (error != NULL) {
-                        g_warning ("Unable to monitor %s: %s", PATH_PASSWD, error->message);
-                        g_error_free (error);
-                } else {
-                        g_warning ("Unable to monitor %s", PATH_PASSWD);
-                }
-        }
-        g_object_unref (file);
-
-
-        get_seat_proxy (manager);
-
-        queue_reload_users (manager);
-
-        manager->priv->users_dirty = FALSE;
+        return g_hash_table_lookup (manager->user_by_name, name);
 }
 
-static void
-gdm_user_manager_finalize (GObject *object)
+GdmUser *
+gdm_user_manager_get_user_by_id (GdmUserManager *manager,
+                                uid_t          uid)
 {
-        GdmUserManager *manager;
-
-        g_return_if_fail (object != NULL);
-        g_return_if_fail (GDM_IS_USER_MANAGER (object));
-
-        manager = GDM_USER_MANAGER (object);
-
-        g_return_if_fail (manager->priv != NULL);
-
-        if (manager->priv->seat_proxy != NULL) {
-                g_object_unref (manager->priv->seat_proxy);
-        }
+        struct  passwd *pwent;
 
-        if (manager->priv->ck_history_id != 0) {
-                g_source_remove (manager->priv->ck_history_id);
-                manager->priv->ck_history_id = 0;
-        }
-
-        if (manager->priv->reload_id > 0) {
-                g_source_remove (manager->priv->reload_id);
-                manager->priv->reload_id = 0;
+        pwent = getpwuid (uid);
+        if (!pwent) {
+                return NULL;
         }
 
-        g_hash_table_destroy (manager->priv->sessions);
-
-        g_file_monitor_cancel (manager->priv->passwd_monitor);
-        g_hash_table_destroy (manager->priv->users);
-
-        g_file_monitor_cancel (manager->priv->shells_monitor);
-        g_hash_table_destroy (manager->priv->shells);
-
-        g_free (manager->priv->seat_id);
-
-        G_OBJECT_CLASS (gdm_user_manager_parent_class)->finalize (object);
+        return gdm_user_manager_get_user (manager, pwent->pw_name);
 }
 
-GdmUserManager *
-gdm_user_manager_ref_default (void)
+gboolean
+gdm_user_manager_no_service (GdmUserManager *manager)
 {
-        if (user_manager_object != NULL) {
-                g_object_ref (user_manager_object);
-        } else {
-                user_manager_object = g_object_new (GDM_TYPE_USER_MANAGER, NULL);
-                g_object_add_weak_pointer (user_manager_object,
-                                           (gpointer *) &user_manager_object);
-        }
-
-        return GDM_USER_MANAGER (user_manager_object);
+        return manager->no_service;
 }
